// #autoload
// #name = dropper
// #version = 1.0
// #date = July 5, 2001
// #author = |eX|DEbig3
// #warrior =  DEbig3
// #email = debig3@qwest.net
// #web = http://scripts.tribalwar.com/debig3
// #description = gives a easy interface for dropping pretty much anything you can carry
// #credit = presto, for being the leet t1 scripter
// #status = release
// #readme =

function dropperBuildMenus() {
	%resx = getWord($pref::Video::resolution, 0);
	if (%resx == "640") {
		$dropperpos = "20 255";
	}
	else if (%resx == "800") {
		$dropperpos = "20 375";
	}
	else if (%resx == "1024") {
		$dropperpos = "20 543";
	}
	else if (%resx == "1280") {
		$dropperpos = "20 799";
	}
	else if (%resx == "1600") {
		$dropperpos = "20 975";
	}
	$dropperMainMenu = new ShellFieldCtrl(dropperMainMenu) {
			profile = "GuiChatBackProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = $dropperpos;
			extent = "100 175";
			minExtent = "2 2";
			visible = "0";
			schedule = "";
	};
	$dropperWeaponMenu = new ShellFieldCtrl(dropperWeaponMenu) {
			profile = "GuiChatBackProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = $dropperpos;
			extent = "100 175";
			minExtent = "2 2";
			visible = "0";
			schedule = "";
	};
	$dropperAmmoMenu = new ShellFieldCtrl(dropperAmmoMenu) {
			profile = "GuiChatBackProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = $dropperpos;
			extent = "100 175";
			minExtent = "2 2";
			visible = "0";
			schedule = "";
	};
	$dropperMiscMenu = new ShellFieldCtrl(dropperMiscMenu) {
			profile = "GuiChatBackProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = $dropperpos;
			extent = "100 175";
			minExtent = "2 2";
			visible = "0";
			schedule = "";
	};
	playgui.add($dropperMainMenu);
	playgui.add($dropperWeaponMenu);
	playgui.add($dropperAmmoMenu);
	playgui.add($dropperMiscMenu);
	$dropperMainMenu.text = new GuiMLTextCtrl() {
			profile = "GuiTextObjHudCenterProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = "0 0";
			extent = "100 175";
			visible = "1";
	};
	$dropperWeaponMenu.text = new GuiMLTextCtrl() {
			profile = "GuiTextObjHudCenterProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = "0 0";
			extent = "100 175";
			visible = "1";
	};
	$dropperAmmoMenu.text = new GuiMLTextCtrl() {
			profile = "GuiTextObjHudCenterProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = "0 0";
			extent = "100 175";
			visible = "1";
	};
	$dropperMiscMenu.text = new GuiMLTextCtrl() {
			profile = "GuiTextObjHudCenterProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = "0 0";
			extent = "100 175";
			visible = "1";
	};
	$dropperMainMenu.add($dropperMainMenu.text);
	$dropperWeaponMenu.add($dropperWeaponMenu.text);
	$dropperAmmoMenu.add($dropperAmmoMenu.text);
	$dropperMiscMenu.add($dropperMiscMenu.text);
	$dropperMainMenu.text.setValue("Dropper Menu:\nW: Weapons\nA: Ammo\nM: Misc");
	$dropperWeaponMenu.text.setValue("Weapon Drop:\nB: Blaster\nC: Chaingun\nP: Plasma\nD: Disc\nG: Gren Launcher\nM: Mortar\nE: ELF\nL: Laser Rifle\nS: Shocklance\nI: Missile");
	$dropperAmmoMenu.text.setValue("Ammo Drop:\nC: Chaingun\nP: Plasma\nD: Disc\nG: Gren Launcher\nM: Mortar\nI: Missile");
	$dropperMiscMenu.text.setValue("Misc Drop:\nP: Pack\nR: Repair Kit\nG: Grenade\nM: Mine\nB: Beacon");
}

function dropperSetBinds() {
	if (!isObject(mainDropperBinds))
		new actionMap(mainDropperBinds);
	if (!isObject(weaponDropperBinds))
		new actionMap(weaponDropperBinds);
	if (!isObject(ammoDropperBinds))
		new actionMap(ammoDropperBinds);
	if (!isObject(miscDropperBinds))
		new actionMap(miscDropperBinds);
	mainDropperBinds.bindCmd(keyboard, "escape", "dropperCloseMenus();", "");
	mainDropperBinds.bindCmd(keyboard, "w", "dropperOpenWeaponMenu();", "");
	mainDropperBinds.bindCmd(keyboard, "a", "dropperOpenAmmoMenu();", "");
	mainDropperBinds.bindCmd(keyboard, "m", "dropperOpenMiscMenu();", "");
	weaponDropperBinds.bindCmd(keyboard, "escape", "dropperCloseMenus();", "");
	weaponDropperBinds.bindCmd(keyboard, "b", "dropperThrow(Blaster);", "");
	weaponDropperBinds.bindCmd(keyboard, "p", "dropperThrow(Plasma);", "");
	weaponDropperBinds.bindCmd(keyboard, "c", "dropperThrow(Chaingun);", "");
	weaponDropperBinds.bindCmd(keyboard, "d", "dropperThrow(Disc);", "");
	weaponDropperBinds.bindCmd(keyboard, "g", "dropperThrow(GrenadeLauncher);", "");
	weaponDropperBinds.bindCmd(keyboard, "m", "dropperThrow(Mortar);", "");
	weaponDropperBinds.bindCmd(keyboard, "e", "dropperThrow(ELFGun);", "");
	weaponDropperBinds.bindCmd(keyboard, "l", "dropperThrow(SniperRifle);", "");
	weaponDropperBinds.bindCmd(keyboard, "s", "dropperThrow(Shocklance);", "");
	weaponDropperBinds.bindCmd(keyboard, "i", "dropperThrow(MissileLauncher);", "");
	ammoDropperBinds.bindCmd(keyboard, "escape", "dropperCloseMenus();", "");
	ammoDropperBinds.bindCmd(keyboard, "p", "dropperThrow(PlasmaAmmo);", "");
	ammoDropperBinds.bindCmd(keyboard, "c", "dropperThrow(ChaingunAmmo);", "");
	ammoDropperBinds.bindCmd(keyboard, "d", "dropperThrow(DiscAmmo);", "");
	ammoDropperBinds.bindCmd(keyboard, "g", "dropperThrow(GrenadeLauncherAmmo);", "");
	ammoDropperBinds.bindCmd(keyboard, "m", "dropperThrow(MortarAmmo);", "");
	ammoDropperBinds.bindCmd(keyboard, "i", "dropperThrow(MissileLauncherAmmo);", "");
	miscDropperBinds.bindCmd(keyboard, "escape", "dropperCloseMenus();", "");
	miscDropperBinds.bindCmd(keyboard, "p", "dropperThrow(Pack);", "");
	miscDropperBinds.bindCmd(keyboard, "r", "dropperThrow(RepairKit);", "");
	miscDropperBinds.bindCmd(keyboard, "g", "dropperThrow(Grenade);", "");
	miscDropperBinds.bindCmd(keyboard, "m", "dropperThrow(Mine);", "");
	miscDropperBinds.bindCmd(keyboard, "b", "dropperThrow(Beacon);", "");
}

function dropperOpenMenu(%val) {
if (%val) {
	dropperCloseMenus();
	$dropperMainMenu.setVisible("1");
	mainDropperBinds.push();
}
}

function dropperOpenWeaponMenu() {
	dropperCloseMenus();
	$dropperWeaponMenu.setVisible("1");
	weaponDropperBinds.push();
}

function dropperOpenAmmoMenu() {
	dropperCloseMenus();
	$dropperAmmoMenu.setVisible("1");
	ammoDropperBinds.push();
}

function dropperOpenMiscMenu() {
	dropperCloseMenus();
	$dropperMiscMenu.setVisible("1");
	miscDropperBinds.push();
}

function dropperCloseMenus() {
	$dropperMainMenu.setVisible("0");
	$dropperWeaponMenu.setVisible("0");
	$dropperAmmoMenu.setVisible("0");
	$dropperMiscMenu.setVisible("0");
	mainDropperBinds.pop();
	weaponDropperBinds.pop();
	ammoDropperBinds.pop();
	miscDropperBinds.pop();
}

function dropperThrow(%item) {
	echo("throw called");
	if (%item $= "Pack") {
		throwPack(1);
	}
	else {
		throw(%item);
	}
	dropperCloseMenus();
}

function dropperSetHudPosition() {
	dropperMainMenu.position = $dropperpos;
	dropperWeaponMenu.position = $dropperpos;
	dropperAmmoMenu.position = $dropperpos;
	dropperMiscMenu.position = $dropperpos;
}

package dropperBind {
	function OptionsDlg::onWake( %this ) {
		if (!$dropperBind) {
			$RemapName[$RemapCount]="Dropper";
			$RemapCmd[$RemapCount]="dropperOpenMenu";
			$RemapCount++;
			$dropperBind = true;
		}
		parent::onWake( %this );
	}

	function PlayGui::onWake(%this) {
		parent::onWake(%this);
		dropperBuildMenus();
		dropperSetBinds();
		schedule(2000, 0, dropperSetHudPosition);
	}
};

activatePackage(dropperBind);